/*
 * Copyright (c) 2000-2004 Apple Computer, Inc. All rights reserved.
 *
 * @APPLE_OSREFERENCE_LICENSE_HEADER_START@
 * 
 * This file contains Original Code and/or Modifications of Original Code
 * as defined in and that are subject to the Apple Public Source License
 * Version 2.0 (the 'License'). You may not use this file except in
 * compliance with the License. The rights granted to you under the License
 * may not be used to create, or enable the creation or redistribution of,
 * unlawful or unlicensed copies of an Apple operating system, or to
 * circumvent, violate, or enable the circumvention or violation of, any
 * terms of an Apple operating system software license agreement.
 * 
 * Please obtain a copy of the License at
 * http://www.opensource.apple.com/apsl/ and read it before using this file.
 * 
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
 * Please see the License for the specific language governing rights and
 * limitations under the License.
 * 
 * @APPLE_OSREFERENCE_LICENSE_HEADER_END@
 */
#ifndef	_KERN_SPL_H_
#define	_KERN_SPL_H_

#include <machine/machine_routines.h>

#if defined (__DARLING__)
typedef unsigned long  spl_t;

extern unsigned long duct_ml_irqsave_setenabled (boolean_t enable);
extern void duct_ml_irqrestore (unsigned long flags);

#define	splhigh()       duct_ml_irqsave_setenabled (FALSE)
#define	splsched()      duct_ml_irqsave_setenabled (FALSE)
#define	splclock()      duct_ml_irqsave_setenabled (FALSE)
#define	splx(flags)     duct_ml_irqrestore (flags)
#define	spllo()         duct_ml_irqsave_setenabled (TRUE)

#else
typedef unsigned spl_t;

#define	splhigh()	(spl_t) ml_set_interrupts_enabled(FALSE)
#define	splsched()	(spl_t) ml_set_interrupts_enabled(FALSE)
#define	splclock()	(spl_t) ml_set_interrupts_enabled(FALSE)
#define	splx(x)		(void) ml_set_interrupts_enabled(x)
#define	spllo()		(void) ml_set_interrupts_enabled(TRUE)
#endif

#endif	/* _KERN_SPL_H_ */
