#ifndef	_host_notify_reply_server_
#define	_host_notify_reply_server_

/* Module host_notify_reply */

#include <string.h>
#include <mach/ndr.h>
#include <mach/boolean.h>
#include <mach/kern_return.h>
#include <mach/notify.h>
#include <mach/mach_types.h>
#include <mach/message.h>
#include <mach/mig_errors.h>
#include <mach/port.h>

#ifdef AUTOTEST
#ifndef FUNCTION_PTR_T
#define FUNCTION_PTR_T
typedef void (*function_ptr_t)(mach_port_t, char *, mach_msg_type_number_t);
typedef struct {
        char            *name;
        function_ptr_t  function;
} function_table_entry;
typedef function_table_entry   *function_table_t;
#endif /* FUNCTION_PTR_T */
#endif /* AUTOTEST */

#ifndef	host_notify_reply_MSG_COUNT
#define	host_notify_reply_MSG_COUNT	1
#endif	/* host_notify_reply_MSG_COUNT */

#include <mach/std_types.h>
#include <mach/mig.h>

#ifdef __BeforeMigServerHeader
__BeforeMigServerHeader
#endif /* __BeforeMigServerHeader */


/* SimpleRoutine host_calendar_changed */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t host_calendar_changed
(
	mach_port_t notify_port
);

#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
boolean_t host_notify_reply_server(
		mach_msg_header_t *InHeadP,
		mach_msg_header_t *OutHeadP);

#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
mig_routine_t host_notify_reply_server_routine(
		mach_msg_header_t *InHeadP);


/* Description of this subsystem, for use in direct RPC */
extern const struct host_notify_reply_subsystem {
	mig_server_routine_t	server;	/* Server routine */
	mach_msg_id_t	start;	/* Min routine number */
	mach_msg_id_t	end;	/* Max routine number + 1 */
	unsigned int	maxsize;	/* Max msg size */
	vm_address_t	reserved;	/* Reserved */
	struct routine_descriptor	/*Array of routine descriptors */
		routine[1];
} host_notify_reply_subsystem;

/* typedefs for all requests */

#ifndef __Request__host_notify_reply_subsystem__defined
#define __Request__host_notify_reply_subsystem__defined

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
	} __Request__host_calendar_changed_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif
#endif /* !__Request__host_notify_reply_subsystem__defined */


/* union of all requests */

#ifndef __RequestUnion__host_notify_reply_subsystem__defined
#define __RequestUnion__host_notify_reply_subsystem__defined
union __RequestUnion__host_notify_reply_subsystem {
	__Request__host_calendar_changed_t Request_host_calendar_changed;
};
#endif /* __RequestUnion__host_notify_reply_subsystem__defined */
/* typedefs for all replies */

#ifndef __Reply__host_notify_reply_subsystem__defined
#define __Reply__host_notify_reply_subsystem__defined

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
	} __Reply__host_calendar_changed_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif
#endif /* !__Reply__host_notify_reply_subsystem__defined */


/* union of all replies */

#ifndef __ReplyUnion__host_notify_reply_subsystem__defined
#define __ReplyUnion__host_notify_reply_subsystem__defined
union __ReplyUnion__host_notify_reply_subsystem {
	__Reply__host_calendar_changed_t Reply_host_calendar_changed;
};
#endif /* __RequestUnion__host_notify_reply_subsystem__defined */

#ifndef subsystem_to_name_map_host_notify_reply
#define subsystem_to_name_map_host_notify_reply \
    { "host_calendar_changed", 950 }
#endif

#ifdef __AfterMigServerHeader
__AfterMigServerHeader
#endif /* __AfterMigServerHeader */

#endif	 /* _host_notify_reply_server_ */
