#ifndef	_map_user_
#define	_map_user_

/* Module map */

#include <string.h>
#include <mach/ndr.h>
#include <mach/boolean.h>
#include <mach/kern_return.h>
#include <mach/notify.h>
#include <mach/mach_types.h>
#include <mach/message.h>
#include <mach/mig_errors.h>
#include <mach/port.h>

#ifdef AUTOTEST
#ifndef FUNCTION_PTR_T
#define FUNCTION_PTR_T
typedef void (*function_ptr_t)(mach_port_t, char *, mach_msg_type_number_t);
typedef struct {
        char            *name;
        function_ptr_t  function;
} function_table_entry;
typedef function_table_entry   *function_table_t;
#endif /* FUNCTION_PTR_T */
#endif /* AUTOTEST */

#ifndef	map_MSG_COUNT
#define	map_MSG_COUNT	31
#endif	/* map_MSG_COUNT */

#include <mach/std_types.h>
#include <mach/mig.h>
#include <mach/mig.h>
#include <mach/mach_types.h>
#include <mach_debug/mach_debug_types.h>

#ifdef __BeforeMigUserHeader
__BeforeMigUserHeader
#endif /* __BeforeMigUserHeader */

#include <sys/cdefs.h>
__BEGIN_DECLS


/* Routine region */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t region
(
	vm_map_t target_task,
	vm32_address_t *address,
	vm32_size_t *size,
	vm_region_flavor_t flavor,
	vm_region_info_t info,
	mach_msg_type_number_t *infoCnt,
	mach_port_t *object_name
);

/* Routine allocate */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t allocate
(
	vm_map_t target_task,
	vm32_address_t *address,
	vm32_size_t size,
	int flags
);

/* Routine deallocate */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t deallocate
(
	vm_map_t target_task,
	vm32_address_t address,
	vm32_size_t size
);

/* Routine protect */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t protect
(
	vm_map_t target_task,
	vm32_address_t address,
	vm32_size_t size,
	boolean_t set_maximum,
	vm_prot_t new_protection
);

/* Routine inherit */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t inherit
(
	vm_map_t target_task,
	vm32_address_t address,
	vm32_size_t size,
	vm_inherit_t new_inheritance
);

/* Routine read */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t read
(
	vm_map_t target_task,
	vm32_address_t address,
	vm32_size_t size,
	vm_offset_t *data,
	mach_msg_type_number_t *dataCnt
);

/* Routine read_list */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t read_list
(
	vm_map_t target_task,
	vm32_read_entry_t data_list,
	natural_t count
);

/* Routine write */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t write
(
	vm_map_t target_task,
	vm32_address_t address,
	vm_offset_t data,
	mach_msg_type_number_t dataCnt
);

/* Routine copy */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t copy
(
	vm_map_t target_task,
	vm32_address_t source_address,
	vm32_size_t size,
	vm32_address_t dest_address
);

/* Routine read_overwrite */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t read_overwrite
(
	vm_map_t target_task,
	vm32_address_t address,
	vm32_size_t size,
	vm32_address_t data,
	vm32_size_t *outsize
);

/* Routine msync */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t msync
(
	vm_map_t target_task,
	vm32_address_t address,
	vm32_size_t size,
	vm_sync_t sync_flags
);

/* Routine behavior_set */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t behavior_set
(
	vm_map_t target_task,
	vm32_address_t address,
	vm32_size_t size,
	vm_behavior_t new_behavior
);

/* Routine map */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t map
(
	vm_map_t target_task,
	vm32_address_t *address,
	vm32_size_t size,
	vm32_address_t mask,
	int flags,
	mem_entry_name_port_t object,
	vm32_offset_t offset,
	boolean_t copy,
	vm_prot_t cur_protection,
	vm_prot_t max_protection,
	vm_inherit_t inheritance
);

/* Routine machine_attribute */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t machine_attribute
(
	vm_map_t target_task,
	vm32_address_t address,
	vm32_size_t size,
	vm_machine_attribute_t attribute,
	vm_machine_attribute_val_t *value
);

/* Routine remap */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t remap
(
	vm_map_t target_task,
	vm32_address_t *target_address,
	vm32_size_t size,
	vm32_address_t mask,
	boolean_t anywhere,
	vm_map_t src_task,
	vm32_address_t src_address,
	boolean_t copy,
	vm_prot_t *cur_protection,
	vm_prot_t *max_protection,
	vm_inherit_t inheritance
);

/* Routine _task_wire */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t _task_wire
(
	vm_map_t target_task,
	boolean_t must_wire
);

/* Routine make_memory_entry */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t make_memory_entry
(
	vm_map_t target_task,
	vm32_size_t *size,
	vm32_offset_t offset,
	vm_prot_t permission,
	mem_entry_name_port_t *object_handle,
	mem_entry_name_port_t parent_entry
);

/* Routine map_page_query */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t map_page_query
(
	vm_map_t target_map,
	vm32_offset_t offset,
	integer_t *disposition,
	integer_t *ref_count
);

/* Routine region_info */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t region_info
(
	vm_map_t task,
	vm32_address_t address,
	vm_info_region_t *region,
	vm_info_object_array_t *objects,
	mach_msg_type_number_t *objectsCnt
);

/* Routine mapped_pages_info */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t mapped_pages_info
(
	vm_map_t task,
	page_address_array_t *pages,
	mach_msg_type_number_t *pagesCnt
);

/* Routine region_recurse */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t region_recurse
(
	vm_map_t target_task,
	vm32_address_t *address,
	vm32_size_t *size,
	natural_t *nesting_depth,
	vm_region_recurse_info_t info,
	mach_msg_type_number_t *infoCnt
);

/* Routine region_recurse_64 */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t region_recurse_64
(
	vm_map_t target_task,
	vm32_address_t *address,
	vm32_size_t *size,
	natural_t *nesting_depth,
	vm_region_recurse_info_t info,
	mach_msg_type_number_t *infoCnt
);

/* Routine region_info_64 */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t region_info_64
(
	vm_map_t task,
	vm32_address_t address,
	vm_info_region_64_t *region,
	vm_info_object_array_t *objects,
	mach_msg_type_number_t *objectsCnt
);

/* Routine region_64 */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t region_64
(
	vm_map_t target_task,
	vm32_address_t *address,
	vm32_size_t *size,
	vm_region_flavor_t flavor,
	vm_region_info_t info,
	mach_msg_type_number_t *infoCnt,
	mach_port_t *object_name
);

/* Routine make_memory_entry_64 */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t make_memory_entry_64
(
	vm_map_t target_task,
	memory_object_size_t *size,
	memory_object_offset_t offset,
	vm_prot_t permission,
	mach_port_t *object_handle,
	mem_entry_name_port_t parent_entry
);

/* Routine map_64 */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t map_64
(
	vm_map_t target_task,
	vm32_address_t *address,
	vm32_size_t size,
	vm32_address_t mask,
	int flags,
	mem_entry_name_port_t object,
	memory_object_offset_t offset,
	boolean_t copy,
	vm_prot_t cur_protection,
	vm_prot_t max_protection,
	vm_inherit_t inheritance
);

/* Routine purgable_control */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t purgable_control
(
	vm_map_t target_task,
	vm32_address_t address,
	vm_purgable_t control,
	int *state
);

__END_DECLS

/********************** Caution **************************/
/* The following data types should be used to calculate  */
/* maximum message sizes only. The actual message may be */
/* smaller, and the position of the arguments within the */
/* message layout may vary from what is presented here.  */
/* For example, if any of the arguments are variable-    */
/* sized, and less than the maximum is sent, the data    */
/* will be packed tight in the actual message to reduce  */
/* the presence of holes.                                */
/********************** Caution **************************/

/* typedefs for all requests */

#ifndef __Request__map_subsystem__defined
#define __Request__map_subsystem__defined

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		vm32_address_t address;
		vm_region_flavor_t flavor;
		mach_msg_type_number_t infoCnt;
	} __Request__region_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		vm32_address_t address;
		vm32_size_t size;
		int flags;
	} __Request__allocate_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		vm32_address_t address;
		vm32_size_t size;
	} __Request__deallocate_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		vm32_address_t address;
		vm32_size_t size;
		boolean_t set_maximum;
		vm_prot_t new_protection;
	} __Request__protect_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		vm32_address_t address;
		vm32_size_t size;
		vm_inherit_t new_inheritance;
	} __Request__inherit_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		vm32_address_t address;
		vm32_size_t size;
	} __Request__read_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		vm32_read_entry_t data_list;
		natural_t count;
	} __Request__read_list_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		/* start of the kernel processed data */
		mach_msg_body_t msgh_body;
		mach_msg_ool_descriptor_t data;
		/* end of the kernel processed data */
		NDR_record_t NDR;
		vm32_address_t address;
		mach_msg_type_number_t dataCnt;
	} __Request__write_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		vm32_address_t source_address;
		vm32_size_t size;
		vm32_address_t dest_address;
	} __Request__copy_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		vm32_address_t address;
		vm32_size_t size;
		vm32_address_t data;
	} __Request__read_overwrite_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		vm32_address_t address;
		vm32_size_t size;
		vm_sync_t sync_flags;
	} __Request__msync_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		vm32_address_t address;
		vm32_size_t size;
		vm_behavior_t new_behavior;
	} __Request__behavior_set_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		/* start of the kernel processed data */
		mach_msg_body_t msgh_body;
		mach_msg_port_descriptor_t object;
		/* end of the kernel processed data */
		NDR_record_t NDR;
		vm32_address_t address;
		vm32_size_t size;
		vm32_address_t mask;
		int flags;
		vm32_offset_t offset;
		boolean_t copy;
		vm_prot_t cur_protection;
		vm_prot_t max_protection;
		vm_inherit_t inheritance;
	} __Request__map_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		vm32_address_t address;
		vm32_size_t size;
		vm_machine_attribute_t attribute;
		vm_machine_attribute_val_t value;
	} __Request__machine_attribute_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		/* start of the kernel processed data */
		mach_msg_body_t msgh_body;
		mach_msg_port_descriptor_t src_task;
		/* end of the kernel processed data */
		NDR_record_t NDR;
		vm32_address_t target_address;
		vm32_size_t size;
		vm32_address_t mask;
		boolean_t anywhere;
		vm32_address_t src_address;
		boolean_t copy;
		vm_inherit_t inheritance;
	} __Request__remap_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		boolean_t must_wire;
	} __Request___task_wire_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		/* start of the kernel processed data */
		mach_msg_body_t msgh_body;
		mach_msg_port_descriptor_t parent_entry;
		/* end of the kernel processed data */
		NDR_record_t NDR;
		vm32_size_t size;
		vm32_offset_t offset;
		vm_prot_t permission;
	} __Request__make_memory_entry_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		vm32_offset_t offset;
	} __Request__map_page_query_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		vm32_address_t address;
	} __Request__region_info_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
	} __Request__mapped_pages_info_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		vm32_address_t address;
		natural_t nesting_depth;
		mach_msg_type_number_t infoCnt;
	} __Request__region_recurse_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		vm32_address_t address;
		natural_t nesting_depth;
		mach_msg_type_number_t infoCnt;
	} __Request__region_recurse_64_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		vm32_address_t address;
	} __Request__region_info_64_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		vm32_address_t address;
		vm_region_flavor_t flavor;
		mach_msg_type_number_t infoCnt;
	} __Request__region_64_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		/* start of the kernel processed data */
		mach_msg_body_t msgh_body;
		mach_msg_port_descriptor_t parent_entry;
		/* end of the kernel processed data */
		NDR_record_t NDR;
		memory_object_size_t size;
		memory_object_offset_t offset;
		vm_prot_t permission;
	} __Request__make_memory_entry_64_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		/* start of the kernel processed data */
		mach_msg_body_t msgh_body;
		mach_msg_port_descriptor_t object;
		/* end of the kernel processed data */
		NDR_record_t NDR;
		vm32_address_t address;
		vm32_size_t size;
		vm32_address_t mask;
		int flags;
		memory_object_offset_t offset;
		boolean_t copy;
		vm_prot_t cur_protection;
		vm_prot_t max_protection;
		vm_inherit_t inheritance;
	} __Request__map_64_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		vm32_address_t address;
		vm_purgable_t control;
		int state;
	} __Request__purgable_control_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif
#endif /* !__Request__map_subsystem__defined */

/* union of all requests */

#ifndef __RequestUnion__map_subsystem__defined
#define __RequestUnion__map_subsystem__defined
union __RequestUnion__map_subsystem {
	__Request__region_t Request_region;
	__Request__allocate_t Request_allocate;
	__Request__deallocate_t Request_deallocate;
	__Request__protect_t Request_protect;
	__Request__inherit_t Request_inherit;
	__Request__read_t Request_read;
	__Request__read_list_t Request_read_list;
	__Request__write_t Request_write;
	__Request__copy_t Request_copy;
	__Request__read_overwrite_t Request_read_overwrite;
	__Request__msync_t Request_msync;
	__Request__behavior_set_t Request_behavior_set;
	__Request__map_t Request_map;
	__Request__machine_attribute_t Request_machine_attribute;
	__Request__remap_t Request_remap;
	__Request___task_wire_t Request__task_wire;
	__Request__make_memory_entry_t Request_make_memory_entry;
	__Request__map_page_query_t Request_map_page_query;
	__Request__region_info_t Request_region_info;
	__Request__mapped_pages_info_t Request_mapped_pages_info;
	__Request__region_recurse_t Request_region_recurse;
	__Request__region_recurse_64_t Request_region_recurse_64;
	__Request__region_info_64_t Request_region_info_64;
	__Request__region_64_t Request_region_64;
	__Request__make_memory_entry_64_t Request_make_memory_entry_64;
	__Request__map_64_t Request_map_64;
	__Request__purgable_control_t Request_purgable_control;
};
#endif /* !__RequestUnion__map_subsystem__defined */
/* typedefs for all replies */

#ifndef __Reply__map_subsystem__defined
#define __Reply__map_subsystem__defined

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		/* start of the kernel processed data */
		mach_msg_body_t msgh_body;
		mach_msg_port_descriptor_t object_name;
		/* end of the kernel processed data */
		NDR_record_t NDR;
		vm32_address_t address;
		vm32_size_t size;
		mach_msg_type_number_t infoCnt;
		int info[10];
	} __Reply__region_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
		vm32_address_t address;
	} __Reply__allocate_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
	} __Reply__deallocate_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
	} __Reply__protect_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
	} __Reply__inherit_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		/* start of the kernel processed data */
		mach_msg_body_t msgh_body;
		mach_msg_ool_descriptor_t data;
		/* end of the kernel processed data */
		NDR_record_t NDR;
		mach_msg_type_number_t dataCnt;
	} __Reply__read_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
		vm32_read_entry_t data_list;
	} __Reply__read_list_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
	} __Reply__write_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
	} __Reply__copy_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
		vm32_size_t outsize;
	} __Reply__read_overwrite_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
	} __Reply__msync_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
	} __Reply__behavior_set_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
		vm32_address_t address;
	} __Reply__map_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
		vm_machine_attribute_val_t value;
	} __Reply__machine_attribute_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
		vm32_address_t target_address;
		vm_prot_t cur_protection;
		vm_prot_t max_protection;
	} __Reply__remap_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
	} __Reply___task_wire_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		/* start of the kernel processed data */
		mach_msg_body_t msgh_body;
		mach_msg_port_descriptor_t object_handle;
		/* end of the kernel processed data */
		NDR_record_t NDR;
		vm32_size_t size;
	} __Reply__make_memory_entry_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
		integer_t disposition;
		integer_t ref_count;
	} __Reply__map_page_query_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		/* start of the kernel processed data */
		mach_msg_body_t msgh_body;
		mach_msg_ool_descriptor_t objects;
		/* end of the kernel processed data */
		NDR_record_t NDR;
		vm_info_region_t region;
		mach_msg_type_number_t objectsCnt;
	} __Reply__region_info_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		/* start of the kernel processed data */
		mach_msg_body_t msgh_body;
		mach_msg_ool_descriptor_t pages;
		/* end of the kernel processed data */
		NDR_record_t NDR;
		mach_msg_type_number_t pagesCnt;
	} __Reply__mapped_pages_info_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
		vm32_address_t address;
		vm32_size_t size;
		natural_t nesting_depth;
		mach_msg_type_number_t infoCnt;
		int info[19];
	} __Reply__region_recurse_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
		vm32_address_t address;
		vm32_size_t size;
		natural_t nesting_depth;
		mach_msg_type_number_t infoCnt;
		int info[19];
	} __Reply__region_recurse_64_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		/* start of the kernel processed data */
		mach_msg_body_t msgh_body;
		mach_msg_ool_descriptor_t objects;
		/* end of the kernel processed data */
		NDR_record_t NDR;
		vm_info_region_64_t region;
		mach_msg_type_number_t objectsCnt;
	} __Reply__region_info_64_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		/* start of the kernel processed data */
		mach_msg_body_t msgh_body;
		mach_msg_port_descriptor_t object_name;
		/* end of the kernel processed data */
		NDR_record_t NDR;
		vm32_address_t address;
		vm32_size_t size;
		mach_msg_type_number_t infoCnt;
		int info[10];
	} __Reply__region_64_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		/* start of the kernel processed data */
		mach_msg_body_t msgh_body;
		mach_msg_port_descriptor_t object_handle;
		/* end of the kernel processed data */
		NDR_record_t NDR;
		memory_object_size_t size;
	} __Reply__make_memory_entry_64_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
		vm32_address_t address;
	} __Reply__map_64_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif

#ifdef  __MigPackStructs
#pragma pack(4)
#endif
	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
		int state;
	} __Reply__purgable_control_t;
#ifdef  __MigPackStructs
#pragma pack()
#endif
#endif /* !__Reply__map_subsystem__defined */

/* union of all replies */

#ifndef __ReplyUnion__map_subsystem__defined
#define __ReplyUnion__map_subsystem__defined
union __ReplyUnion__map_subsystem {
	__Reply__region_t Reply_region;
	__Reply__allocate_t Reply_allocate;
	__Reply__deallocate_t Reply_deallocate;
	__Reply__protect_t Reply_protect;
	__Reply__inherit_t Reply_inherit;
	__Reply__read_t Reply_read;
	__Reply__read_list_t Reply_read_list;
	__Reply__write_t Reply_write;
	__Reply__copy_t Reply_copy;
	__Reply__read_overwrite_t Reply_read_overwrite;
	__Reply__msync_t Reply_msync;
	__Reply__behavior_set_t Reply_behavior_set;
	__Reply__map_t Reply_map;
	__Reply__machine_attribute_t Reply_machine_attribute;
	__Reply__remap_t Reply_remap;
	__Reply___task_wire_t Reply__task_wire;
	__Reply__make_memory_entry_t Reply_make_memory_entry;
	__Reply__map_page_query_t Reply_map_page_query;
	__Reply__region_info_t Reply_region_info;
	__Reply__mapped_pages_info_t Reply_mapped_pages_info;
	__Reply__region_recurse_t Reply_region_recurse;
	__Reply__region_recurse_64_t Reply_region_recurse_64;
	__Reply__region_info_64_t Reply_region_info_64;
	__Reply__region_64_t Reply_region_64;
	__Reply__make_memory_entry_64_t Reply_make_memory_entry_64;
	__Reply__map_64_t Reply_map_64;
	__Reply__purgable_control_t Reply_purgable_control;
};
#endif /* !__RequestUnion__map_subsystem__defined */

#ifndef subsystem_to_name_map_map
#define subsystem_to_name_map_map \
    { "region", 3800 },\
    { "allocate", 3801 },\
    { "deallocate", 3802 },\
    { "protect", 3803 },\
    { "inherit", 3804 },\
    { "read", 3805 },\
    { "read_list", 3806 },\
    { "write", 3807 },\
    { "copy", 3808 },\
    { "read_overwrite", 3809 },\
    { "msync", 3810 },\
    { "behavior_set", 3811 },\
    { "map", 3812 },\
    { "machine_attribute", 3813 },\
    { "remap", 3814 },\
    { "_task_wire", 3815 },\
    { "make_memory_entry", 3816 },\
    { "map_page_query", 3817 },\
    { "region_info", 3818 },\
    { "mapped_pages_info", 3819 },\
    { "region_recurse", 3821 },\
    { "region_recurse_64", 3822 },\
    { "region_info_64", 3823 },\
    { "region_64", 3824 },\
    { "make_memory_entry_64", 3825 },\
    { "map_64", 3826 },\
    { "purgable_control", 3830 }
#endif

#ifdef __AfterMigUserHeader
__AfterMigUserHeader
#endif /* __AfterMigUserHeader */

#endif	 /* _map_user_ */
